﻿package {
	import flash.events.*;
	import flash.display.*;
	import fl.controls.*;
	
	import org.shokai.motion.linetrace.*;
	
	public class LineTrace extends Sprite {
		private var mController:MoveController;
		private var now = 0;
		private var d = 1; // 変化量
		private var mcList:Array;
		
		private var _buttonL:Button;
		private var _buttonR:Button;
		private var _checkBoxShowLine:CheckBox;
		
		/* IDEが生成したオブジェクトを関連づけ */
		public function link_ide_obj():void{
			_buttonL = buttonL;
			_buttonR = buttonR;
			_checkBoxShowLine = checkBoxShowLine;
		}
		
		public function LineTrace() {
			stage.scaleMode = StageScaleMode.EXACT_FIT;
			stage.align = StageAlign.TOP_LEFT;
			
			link_ide_obj();
									
			mcList = new Array();
			mController = new MoveController(50); // 移動点の間の分割量
			
			// 移動する点を設定
			mController.addPoint(-100,200, 60); // x,y,rotation
			mController.addPoint(200, 300, 0);
			mController.addPoint(440, 300, 0);
			mController.addPoint(740, 200, -60);
			// trace(mController.total+"分割");
			
			for(var i:int = 0; i < 100; i++){
				var mc:TestMc = new TestMc();
				mc.alpha = 0.5;
				this.addChild(mc);
				mc.pos = 0; // 初期位置
				mc.setName(i.toString());
				mController.moveMC(mc, mc.pos);
				mcList.push(mc);
			}
						
			this.addEventListener(Event.ENTER_FRAME, reload); // 毎フレーム実行
			_buttonL.addEventListener(MouseEvent.CLICK, function(){ d-=5 });
			_buttonR.addEventListener(MouseEvent.CLICK, function(){ d+=5 });
			_checkBoxShowLine.addEventListener(Event.CHANGE, checkBoxShowLine_changed);
		}
		
		public function checkBoxShowLine_changed(e:Event) {
			if(_checkBoxShowLine.selected){
				mController.drawLines(this);
				mController.drawPoints(this);
			}
			else graphics.clear();
		}
		
		public function reload(e:Event):void{
			now+=d;
			d*=0.9;
			for(var i:int = 0; i < mcList.length; i++){
				var mc:MovieClip = mcList[i];
				mc.pos = now-i*25; // 25間隔
				if(0 <= mc.pos && mc.pos < mController.total){
					mController.moveMC(mc, mc.pos);
				}
			}
		}
				
	}
}